#!/usr/bin/perl
# EasyHost
# Built by CyberScript
# Website: http://www.cyberscript.net
# Email: rcampbell@cyberscript.net
# (C) Copyright 2001, All Rights Reserved.
#####################################################
# The following code may not be modified            #
# or redistributed by anyone other then CyberScript #
#####################################################

$pwd = ($0 =~ /^(.+)[\/\\]/)[0] || '.';
require ("$pwd/cs-lib.pl");

&prepare() if ($ENV{REQUEST_METHOD} eq 'POST');

print &ct("text/html").&display("create_user");

exit (0);

sub prepare {
	&error("The username field is required","name") if (! ( $tokens{name}=lc($tokens{name}) ) );
	&error("The username field contains invalid characters","name") if ($tokens{name} !~ /^[\w\-]+$/);
	&error("The username you entered has already been taken","name") if (&user_exist($tokens{name}));
	&error("The username field must be between $tokens{name_min} to $tokens{name_max} characters in length","name") if (length($tokens{name}) < $tokens{name_min} || length($tokens{name}) > $tokens{name_max});
	&error("The username you entered has been reserved","name") if ($tokens{reserved_names} =~ /(^|,|, )$tokens{name}( ,|,|$)/);

	&error("The password field is required","password") if (!$tokens{password});
	&error("The password field must be between $tokens{password_min} to $tokens{password_max} characters in length","password") if (length($tokens{password}) < $tokens{password_min} || length($tokens{password}) > $tokens{password_max});
	&error("The password field must not be the same as your username","password") if ($tokens{password} eq $tokens{name});
	&error("The password field doesn't match what you re-typed","password") if ($tokens{password} ne $tokens{password2});

	&error("The email address field is required","email") if (!$tokens{email});
	&error("The email address field contains invalid characters","email") if ($tokens{email} !~ /.+\@[\w\-\.]{4,}/);

	&error("The title field is required","title") if (!$tokens{title});
	&error("The title field must be between $tokens{title_min} to $tokens{title_max} characters in length","title") if (length($tokens{title}) < $tokens{title_min} || length($tokens{title}) > $tokens{title_max});

	&error("The description field is required","description") if (!$tokens{description} && $tokens{description_required} eq 'on');
	&error("The description field must be less then or equal to $tokens{description_max} characters in length","description") if (length($tokens{description}) > $tokens{description_max});

	if (!$tokens{error_message}) {

		$tokens{usage}=0;
		$tokens{date_modified} = $tokens{date_created} = time;

		&default_copy();

		$tokens{status} = 1;

		my %data = map { $_ => $tokens{$_} } ('password','email','title','description','status','usage','date_created','date_modified');

		$data{password} = crypt($data{password},'as');

		&user_create($tokens{name},%data);

		$tokens{c} = "done";
	}
}

sub default_copy {
	my ($dir)=@_;

	if ($dir ne "") {
		mkdir("$tokens{root_dir}/$tokens{name}/$dir",0755) || &error("Can't create directory ($tokens{root_dir}/$tokens{name}/$dir): $!");

		opendir(DIR,"$tokens{data_dir}/default/$dir");
		my @dir=readdir(DIR);
		closedir(DIR);

		foreach (@dir) {
			next if ($_ =~ /^\.+$/);

			if (-d "$tokens{data_dir}/default/$dir/$_") {
				&default_copy("$dir/$_");
			} elsif (/\.(html|htm|asp|shtml|shtm|php)$/i) {
				&file_write("$tokens{root_dir}/$tokens{name}/$dir/$_",&file("$tokens{data_dir}/default/$dir/$_"));
				$tokens{usage} += (stat("$tokens{root_dir}/$tokens{name}/$dir/$_"))[7];
			} else {
				&file_write("$tokens{root_dir}/$tokens{name}/$dir/$_",&file_read("$tokens{data_dir}/default/$dir/$_"));
				$tokens{usage} += (stat("$tokens{root_dir}/$tokens{name}/$dir/$_"))[7];
			}
		}
	} else {
		mkdir("$tokens{root_dir}/$tokens{name}",0755) || &error("Can't create directory ($tokens{root_dir}/$tokens{name}): $!");

		opendir(DIR,"$tokens{data_dir}/default");
		my @dir=readdir(DIR);
		closedir(DIR);

		foreach (@dir) {
			next if ($_ =~ /^\.+$/);

			if (-d "$tokens{data_dir}/default/$_") {
				&default_copy($_);
			} elsif (/\.(html|htm|asp|shtml|shtm|php)$/i) {
				&file_write("$tokens{root_dir}/$tokens{name}/$_",&file("$tokens{data_dir}/default/$_"));
				$tokens{usage} += (stat("$tokens{root_dir}/$tokens{name}/$_"))[7];
			} else {
				&file_write("$tokens{root_dir}/$tokens{name}/$_",&file_read("$tokens{data_dir}/default/$_"));
				$tokens{usage} += (stat("$tokens{root_dir}/$tokens{name}/$_"))[7];
			}
		}
	}
}